# Module 1 Specification

## Goal

This module will ensure that the website and its assets runs in a HELIA instance.
This will add seeds and thus network speed to the content distribution. All the 
assets should be integrated in the project so that it does not depend on centralized
systems. This module is important to ensure frontend decentralization.


## Dependencies
- [ ] Module 0

## ToDo

- [ ] Research HELIA
- [ ] How to solve the website hashing paradigm 
- [ ] Detect and Report issue (Update this specification)
- [ ] Research and test possible solutions.
- [ ] Implement solution to achieve the goal.

## Report

### HELIA Specification
* [Helia library](https://github.com/ipfs/helia)[^1]
* [Helia Examples](https://github.com/ipfs-examples/helia-examples/tree/main/examples/helia-webpack)[^2]
* [Helia Example by Phind](https://www.phind.com/search?cache=v6nzolbm7xl10xvhgfih6bvz)[^3]

### Hashing paradigm

To have a self decentralized website we need to add a hash to the code this hash
known as CID is generated based on all the assets hashed data, so it makes a 
paradigm problem to add the hash if its not know previously in the code, because
if we add it to the code of the site, the project hash will change.

### Possible solutions

1. Using SmartContract: Use a smart contract with an IPNS and a ENS
(Ethereum Name Service NFT) which points to an IPNS that will be updated by the
project developer. This gives us the flexibility to update, and security that
the blockchain offers. This can also be an alternative to avoid MITM and other
security issues.

    * Pros: ToDo

    * Cons: ToDo
2. 

## Notes and further developments.

1. Make the ENS Updateable by a DAO and a smart wallet.

## References

[^1]: https://github.com/ipfs/helia
[^2]: https://github.com/ipfs-examples/helia-examples/tree/main/examples/helia-webpack
